#! /usr/bin/python

import gobject, dbus, time
from dbus.mainloop.glib import DBusGMainLoop
   
def handle_call(obj_path, callernumber):
     global blocklist
     for number in blocklist:
         if number.replace("\n","") == callernumber:  
         	print callernumber
		time.sleep (3.0);	### if ringing last longer than 3sec., it's not drop call (you can make it longer if you want)
         	bus = dbus.SystemBus()
		callobject = bus.get_object('com.nokia.csd.Call', '/com/nokia/csd/call/1') 	# Checking call status
		smsiface = dbus.Interface(callobject, 'com.nokia.csd.Call.Instance')
   		smsiface.GetStatus()
   		if smsiface.GetStatus() == 0: 		# if call-status is IDLE (0), ringing is over...it was DROP CALL
   			bus = dbus.SystemBus()
			callobject = bus.get_object('com.nokia.csd.Call', '/com/nokia/csd/call')	# calling back
			smsiface = dbus.Interface(callobject, 'com.nokia.csd.Call')
  			smsiface.CreateWith(str(callernumber), dbus.UInt32(0))	
   			####
   			var = 0
			while var == 0:              
				print "Waiting for ringing sound..."
				bus = dbus.SystemBus()
			   	callobject = bus.get_object('com.nokia.csd.Call', '/com/nokia/csd/call/1')	# Checking call status
			   	smsiface = dbus.Interface(callobject, 'com.nokia.csd.Call.Instance')
				smsiface.GetStatus()
			   	if (smsiface.GetStatus() == 4) or (smsiface.GetStatus() == 8) or (smsiface.GetStatus() == 10) or (smsiface.GetStatus() == 7) or (smsiface.GetStatus() == 11) or (smsiface.GetStatus() == 12) or (smsiface.GetStatus() == 15):	# finish it if call is: ringing,answered(active),busy,answered,on hold,on hold,terminated
			   		#time.sleep (0.5);			# How long you want to let it ring
			   		print "Done!"
					bus = dbus.SystemBus()
					callobject = bus.get_object('com.nokia.csd.Call', '/com/nokia/csd/call/1')
					smsiface = dbus.Interface(callobject, 'com.nokia.csd.Call.Instance')
					smsiface.Release()
      					break


blocklist = ["+38761123456","+38762123456","1111"]		### list of numbers that you're expecting drop call from

DBusGMainLoop(set_as_default=True)
bus = dbus.SystemBus()
bus.add_signal_receiver(handle_call, path='/com/nokia/csd/call', dbus_interface='com.nokia.csd.Call', signal_name='Coming')
gobject.MainLoop().run()
